dnl ----------------------=|=--- video.m4 ---=|=-----------------------------
dnl --=-- Some simple video output on a CGA/VGA text display --=--
dnl
dnl
dnl Lots of info taken from the sources of the Linux console driver.
dnl
Provide({video},{
dnl
dnl

pmpart


dnl
dnl
dnl ----- Firstly, a simple Video Text Device Driver -----
dnl


__dataseg__({
.align 4


;Struc({Video_Text_Device_},{
;	_long_(Buffer_base)
;	_long_()}) ....

Video_mem_base:		.long 0xB8000
Video_port_select:	.word 0x3D4
Video_port_value:	.word 0x3D5

Video_ROWS:		.long 80
Video_LINES:		.long 25
Video_SCREENSIZE:	.long 2000

Video_cursor_X		= alallot(u,4)
Video_cursor_Y		= alallot(u,4)

Video_cursor_shape_top:	.byte 16
Video_cursor_shape_bot:	.byte 16

})

DefWord({Video_Cursor_XY})
	Enter
	outb([Video_port_select],0x15)
	outb([Video_port_value],pointb(DSP))
	outb([Video_port_select],0x14)
	outb([Video_port_value],TOSLL)
	PopmData(2)
	Next

dnl
dnl
dnl ----- A generic VideoText to Console Functor -----
dnl




ConsoleFlags	= allot(u,1)
define({ConFlag_EOL},		0x01)	; are we at the end of line
define({ConFlag_ExistsCursor},	0x02)
define({ConFlag_CR_LFed},	0x04)
define({ConFlag_LF_CRed},	0x08)

ConsoleMode	= allot(u,1)
define({ConMode_HideCursor},	0x01)
define({ConMode_AutoCRLF},	0x02)
define({ConMode_CRdoesLF},	0x04)
define({ConMode_LFdoesCR},	0x08)

CurrentLine	= alallot(u,CELL)	; *address* of beginning of line
CurrentColumn	= alallot(u,CELL)


DefWord(CPUTC)
	Enter
	
	Next


forget({
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; IO Functions ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;;;; Buffered BIOS-based Console output ;;;;
__udataseg__({

; Buffer for Buffered BIOS-based Console output.
define({BBO_BUFSIZE},	256)
BBO_Buffer	= allot(u,BBO_BUFSIZE)
})

__dataseg__({
BBO_BP		.long	0
})

__codeseg__({
BBPutc:
	pushad
	mov edi,[pmaddr(BBO_BP)]
	cld
	stosb
	__IF__(ae)
	  cmp edi,#BBO_BUFSIZE
	__THEN__
	  call BBOFlush
	__ENDIF__
	popad
	ret

BBOFlush:
	;mov eax,[rmaddr(__PD__)]
	;push #rmaddr(RM_BBOFlush)
	jmp Go_BIOS_Real
})})



dnl
dnl
})dnl ---------- end of vp.m4 ------------------
dnl
